REM 2005 (c) Copyright IBM Corp.
REM All Rights Reserved.

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 				  2005 (c) Copyright IBM Corp
:: 					All Rights Reserved
::   
:: OVERVIEW:
::   
:: This processes files included with the RFT6.0's RefreshPack1's
:: iFix001.  
:: 
:: Note that this exact same script is included as the install.bat for
:: the updater.rft_specific.win32.install.611.if001 feature and as the
:: uninstall.bat for the
:: updater.rft_specific.win32.uninstall.611.if001 feature.  
:: 
:: Also note that this script can me modified to process other common
:: siebel files by uncommenting lines below.  
::
:: AUTHOR:  Christopher Maguire
::   
:: DATE			COMMENT
:: 2005.10.03	Initial version of script.
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

CALL :ECHO_OFF
CALL :LogHeader Start %0
CALL :SetGlobals %0 %1
if %ACTION% == "UNINSTALL" (
	cd %1\..
)
CALL :Main
CALL :LogHeader End %0
GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: This script is copied to the uninstall proxy's uninstall.bat.
:: When run as uninstall.bat, it is NOT run from the uninstall proxy.
:: To determine if we're being run as install.bat or uninstall.bat we look where we are.
:: If we're uninstalling, 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:SetGlobals
	if EXIST ..\..\..\..\eclipse\features (
		SET ACTION="INSTALL"
	) else (
		SET ACTION="UNINSTALL"
	)
	SET PROD_INSTALL=%2
	SET RFTPlugins=%PROD_INSTALL%\FunctionalTester\eclipse\plugins
	SET WSW=%RFTPlugins%\com.rational.test.ft.wswplugin_6.1.0
	SET SIEBEL_DIR=%PROD_INSTALL%\FunctionalTester\Siebel
	SET ERR_CODE=0
	SET result=""
	SET regasmutil=%windir%\Microsoft.NET\Framework\v1.1.4322\regasm.exe
	SET msdnhelpfolder=%PROD_INSTALL%\FunctionalTester\MSDNHelp
	GOTO :EOF

:Main
	CALL :CheckGacUtility
	if not %ERR_CODE% == 0 GOTO :EOF
	CALL :GacWithPolicyFile %WSW% rtxftnet.dll policy.6.1.rtxftnet.dll
	GOTO :EOF

:ECHO_ON
	@ECHO ON
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 						 ECHO OFF (but for now, let's just leave it on all the time)
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:ECHO_OFF
	@ECHO ON
	GOTO :EOF

:LogHeader
	echo "---------------- %1 %2 -----------------"
	Date /T
	Time /T
	echo "Current Directory:"
	cd
	GOTO	:EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 						 Install Siebel
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:InstallSiebel
	CALL :CheckCustomInstaller
																			if not %ERR_CODE% == 0 GOTO :EOF
	CALL :InstallCustomFile /i %SIEBEL_DIR% rational_ft_siebel.jar
																			if not %ERR_CODE% == 0 GOTO :EOF
	CALL :CheckForDotNetFramework
	if not %ERR_CODE% == 0 (
		SET ERR_CODE=0
		CALL :SetCustDir
		CALL :FixPartialSiebelInstall
		GOTO :EOF
	)
	CALL :InstallCustomFile /i %SIEBEL_DIR% rational_ft_siebel.rftcust
																			if not %ERR_CODE% == 0 GOTO :EOF
	CALL :InstallCustomFile /r %SIEBEL_DIR% SiebelDomainProxies.dll
																			if not %ERR_CODE% == 0 GOTO :EOF
	CALL :InstallCustomFile /r %SIEBEL_DIR% SiebelIEHelper.dll
																			if not %ERR_CODE% == 0 GOTO :EOF
	CALL :InstallCustomFile /r %SIEBEL_DIR% SiebelNotificationListener.dll
																			if not %ERR_CODE% == 0 GOTO :EOF
	CALL :SetCustDir
	CALL :GacInCustDir %SIEBEL_DIR% Interop.cascomlib.dll
																			if not %ERR_CODE% == 0 GOTO :EOF
	CALL :GacInCustDir %SIEBEL_DIR% Interop.Shdocvw.dll
																			if not %ERR_CODE% == 0 GOTO :EOF
	CALL :GacInCustDir %SIEBEL_DIR% Interop.mshtml.dll
																			if not %ERR_CODE% == 0 GOTO :EOF
	CALL :GacInCustDir %SIEBEL_DIR% SiebelDomainProxies.dll
																			if not %ERR_CODE% == 0 GOTO :EOF
	CALL :GacInCustDir %SIEBEL_DIR% SiebelIEHelper.dll
																			if not %ERR_CODE% == 0 GOTO :EOF
	CALL :GacInCustDir %SIEBEL_DIR% SiebelNotificationListener.dll
																			if not %ERR_CODE% == 0 GOTO :EOF
	CALL :ImportRegistryFile %SIEBEL_DIR% siebel_defaultapplicationname.reg
																			if not %ERR_CODE% == 0 GOTO :EOF
	CALL :InstallSiebelHelp %SIEBEL_DIR%
																			if not %ERR_CODE% == 0 GOTO :EOF
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 			           Fix Partial Siebel Install
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:FixPartialSiebelInstall
	if not %custDir% == "" (
		echo "Deleting siebel files from %custDir%"
		DIR %custDir%\*siebel*
		DEL /F /Q %custDir%\*siebel*
		echo "Deleting siebel files from %custDir%"
		CALL :InstallCustomFile /i %SIEBEL_DIR% rational_ft_siebel.jar
	) else (
		echo "Unable to fix Partial Siebel Install problem due to inability to compute Customization Dir"
	)
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 			           Set Cust Dir
:: custDir will have double quotes around it.  If we can't find it, it will be "".
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:SetCustDir
	echo "=== Attempting to compute customization directory"
	SET defaultCustDir="C:\Documents and Settings\All Users\Application Data\IBM\RFT\customization"
	SET custDir=
	SET REG_QUERY=reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Rational Software\Rational Test\8" /v "Rational FT Customization Directory"
	for /f "tokens=5*" %%i in ('%REG_QUERY%') do @SET custDir=%%j
	SET custDir="%custDir%"
	if %custDir% == "" (
		echo "=== Unable to compute custDir using reg.exe"
		echo "=== Will try using default value for custDir"
		SET custDir=%defaultCustDir%
	) else (
		echo "=== Computed custDir using reg.exe"
	)
	if EXIST %custDir%\rational_ft_siebel.jar (
		echo "=== Found %custDir%\rational_ft_siebel.jar"
		echo "=== Computing customization directory succeeded"
	) else (
		echo "=== Could not find %custDir%\rational_ft_siebel.jar"
		echo "=== Computing customization directory failed"
		SET custDir=""
	)
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 			           Allow Script Rerun
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:AllowScriptRerun
	CALL :CheckFileExistance %SIEBEL_DIR%\rerun_install.bat
	if not %ERR_CODE% == 0 (
		COPY /Y install.bat %SIEBEL_DIR%\install.bat
		echo install.bat %PROD_INSTALL% > %SIEBEL_DIR%\rerun_install.bat
	)
	SET ERR_CODE=0
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 			           Check GacUtility
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckGacUtility
	CALL :CheckFileExistance gacutility.exe
	if %ERR_CODE%==1 (
		SET result=Gacutility not found
	)
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                     Run GAC Utility
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:GacInCustDir
	SET	ERR_CODE=0
	CALL :CheckFileExistance %1\%2
	IF %ERR_CODE%==1 GOTO :EOF

	if %custDir% == "" (
		SET gacThis= %1\%2
	) else (
		CALL :ECHO_ON
		copy /Y %1\%2 %custDir%\%2
		CALL :ECHO_OFF
		SET gacThis= %custDir%\%2
	)
	CALL :ECHO_ON
	gacutility.exe -a %gacThis% -o
	IF %ERRORLEVEL% == 0 ( 
		CALL :ECHO_OFF
		echo "GACUtility.exe succeeded"
	) else (
		CALL :ECHO_OFF
		SET ERR_CODE=1
		echo "GACUtility.exe Error"
	)
	GOTO :EOF 

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                     Run GAC Utility with Policy file
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:GacWithPolicyFile
	SET	ERR_CODE=0
	CALL :CheckFileExistance %1\%2
	IF %ERR_CODE%==1 GOTO :EOF
	CALL :CheckFileExistance %1\%3
	IF %ERR_CODE%==1 GOTO :EOF

	CALL :ECHO_ON
	gacutility.exe -a %1\%2 -p %1\%3 -o
	IF %ERRORLEVEL% == 0 ( 
		CALL :ECHO_OFF
		echo "GACUtility.exe succeeded"
		GOTO :EOF
	) else (
		CALL :ECHO_OFF
		SET ERR_CODE=1
		echo "GACUtility.exe Error"
	)
	GOTO :EOF 

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 				           Install Custom File
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:InstallCustomFile
	SET	ERR_CODE=0

	CALL :CheckFileExistance %2\%3
	IF %ERR_CODE%==1 GOTO :EOF

	CALL :ECHO_ON
	copy %2\%3 %3
	InstallCustomFile.exe %1 %3
	IF	%ERRORLEVEL% == 0 (
		CALL :ECHO_OFF
		SET ERR_CODE=0
		GOTO	:EOF
	) else (
		IF ERRORLEVEL 1  SET result=ErrorCode 1 : Invalid number of arguments for custom installer
		IF ERRORLEVEL 2  SET result=ErrorCode 2 : Custom File Not Found
		IF ERRORLEVEL 3  SET result=ErrorCode 3 : Custom Folder Not Found
		IF ERRORLEVEL 4  SET result=ErrorCode 4 : Custom Install Command Timed Out
		IF ERRORLEVEL 5  SET result=ErrorCode 5 : Command File Create failure (5)
		IF ERRORLEVEL 6  SET result=ErrorCode 6 : Command File Create failure (6)
		CALL :ECHO_OFF
		SET ERR_CODE=1
	)
	GOTO	:EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 				           Check For Custom Installer 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckCustomInstaller
	CALL :CheckFileExistance InstallCustomFile.exe

	IF %ERR_CODE%==1 (
		SET	result=Custom file installer Not Found
	)
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Check For DotNet Frame Work 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckForDotNetFramework
	CALL :CheckFileExistance %regasmutil%

	IF %ERR_CODE%==1 (
		SET	result=.NET FrameworkNotFound
		echo ".NET FRAMEWORK NOT FOUND"
	) else (
		echo ".NET FRAMEWORK FOUND"
	)
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                                    Import Registry File
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:ImportRegistryFile
	SET	ERR_CODE=0
	CALL :CheckFileExistance %1\%2
	IF %ERR_CODE%==1 GOTO :EOF

	CALL :ECHO_ON
	PUSHD %1
	RegEdit	/s %2
	@IF ERRORLEVEL 1 (
		@CALL :ECHO_OFF
		SET ERR_CODE=1
		SET result=Failed to Import Registry File %1\%2
	)
	POPD
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                                    Install Siebel Help
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:InstallSiebelHelp 
	SET ERR_CODE=0
	IF not EXIST %msdnhelpfolder% (
		echo "Could not find MSDNHelp Folder" 
		echo "%msdnhelpfolder%"
		echo "Skipping MSDN Help Install"
		GOTO :EOF
	)

	echo "Installing MSDNHelp Files"
	CALL :ECHO_ON
    copy %1\Help\msdn %msdnhelpfolder% /y
	@IF ERRORLEVEL 1 (
		@CALL :ECHO_OFF
		SET	ERR_CODE=1
		SET	result=Error in installing MSDNHelp
		GOTO :EOF
	)
	PUSHD %msdnhelpfolder%
	AddHelpCollection.exe -removeplugin "IBM.RATIONAL.IVORY" -childnamespace "IBM.RATIONAL.IVORY.SIEBEL"
	AddHelpCollection.exe -removenamespace "IBM.RATIONAL.IVORY.SIEBEL"
	
	AddHelpCollection.exe -addcollection "IBM.RATIONAL.IVORY.SIEBEL" -collectionpath "." -collectionname "RftAPISiebel"
	AddHelpCollection.exe -addhelpfiles "IBM.RATIONAL.IVORY.SIEBEL" -collectionpath "." -collectionname "RftAPISiebel" -mergename rftapisiebel
	
	AddHelpCollection.exe -addplugin "IBM.RATIONAL.IVORY" -childnamespace "IBM.RATIONAL.IVORY.SIEBEL"
	AddHelpCollection.exe -addfilter "IBM.RATIONAL.IVORY.SIEBEL" -filtername "IBM Rational Functional Test API Reference for Siebel" -filterquery "\"DocSet\" = \"FunctionalTesterDomainAPISiebel\""

	@IF ERRORLEVEL 1 (
		@CALL :ECHO_OFF
		SET ERR_CODE=1
		SET	result=Error in installing MSDNHelp
	) ELSE (
		echo "MSDNHelp has been installed successfully"
	)
	POPD
	GOTO	:EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                                         Check For a file existance
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckFileExistance
	SET	ERR_CODE=0
	IF  EXIST %1 (
		SET result=File Exists
	)else (
		SET result=File Not Found
		SET	ERR_CODE=1
	)
	echo "Searching for file %1....%result%"
	GOTO :EOF 

:EXIT_SUCCESS
	echo "-------------------------  Install Status --------------------------- "
	echo "%0 completed successfully."
	GOTO	:LAST

:EXIT_WARNING
	echo "-------------------------  Install Status --------------------------- "
	echo "%0 Completed with Warning(s)"
	GOTO	:LAST


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: EXIT_ERROR
:: We never want to exit with non-0 error status.  Doing so would
:: abort the entire installation.  Not what we want.
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:EXIT_ERROR
	echo "-------------------------  Install Status --------------------------- "
	echo "%0 failed  with Error : %result%"
	EXIT	0

:LAST
	echo "--------------------------------------------------------------------- "
